<script lang="ts">
  /** @type {import('./$types').PageData} */
  export let data: {
    id: number | 'new';
  };
  import { browser } from '$app/environment';
  import { beforeNavigate } from '$app/navigation';
  import { error } from '@sveltejs/kit';
  import { goto } from '$app/navigation';
  import type { Policy } from '$lib';
  import { flashMessage, policies, routes, successMessage, errorMessage } from '$lib/stores';
  import Sidebar from '$lib/Sidebar.svelte';
  import SuccessMessage from '$lib/SuccessMessage.svelte';
  import ErrorMessage from '$lib/ErrorMessage.svelte';
  import Dropdown from '$lib/Dropdown.svelte';
  import ExpressionElement from '$lib/ExpressionElement.svelte';
  import DeleteButton from '$lib/DeleteButton.svelte';

  let policy: Policy = {
    id: 0, // Note: is set on save to a unique ID
    name: '',
    rules: [],
  };

  // Reset success and error messages on page load
  successMessage.set('');
  errorMessage.set('');

  if (browser && data.id !== 'new') {
    // Note: instead of checking `browser`, we could also set this using `onMount`
    const pol = $policies.find((p) => p.id === data.id);
    if (pol === undefined) {
      error(404, 'Policy niet gevonden');
    }

    policy = pol;
  }

  const oldPolicyJSON = JSON.stringify(policy);

  function savePolicy() {
    policies.update((items) => {
      const index = items.findIndex((item) => item.id === policy.id);

      if (index === -1) {
        // In case of a new policy (or if it has been deleted in the meanwhile), give it a unique ID and push it to the list of policies
        let id = 1; // Note: instead of setting policy.id, to prevent an infinite loop in case `policy` is a reference to an element of `items` (which probably is not the case, but to be sure)

        while (items.findIndex((item) => item.id === id) !== -1) {
          id++;
        }
        policy.id = id;
        items.push(policy);
      } else {
        // In case of an existing policy, update it
        items[index] = policy;
      }

      return items;
    });

    isDirty = false;

    // Set a flash message and programmatically navigate to /policies
    flashMessage.set(`Policy '${policy.name || 'Onbekend'}' is opgeslagen.`);
    goto('/policies');
  }

  function deletePolicy() {
    // Update all routes that were linked to this policy
    routes.update((items) => {
      items.forEach((route, i) => {
        if (route.policyId === policy.id) {
          items[i].policyId = undefined;
        }
      });

      return items;
    });

    // Delete the policy (if it occurs in the store)
    policies.update((items) => items.filter((item) => item.id !== policy.id));

    isDirty = false;

    // Set a flash message and programmatically navigate to /policies
    flashMessage.set(`Policy '${policy.name || 'Onbekend'}' is verwijderd.`);
    goto('/policies');
  }

  function deleteRule(i: number): undefined {
    policy.rules.splice(i, 1);
    policy.rules = policy.rules; // Re-render the elements
  }

  // Warn the user before leaving the page in case of unsaved changes
  let isDirty = false;

  function beforeUnload(e: Event) {
    if (isDirty) {
      e.preventDefault();
      // @ts-ignore:next-line This is recommended for legacy reasons, see https://developer.mozilla.org/en-US/docs/Web/API/Window/beforeunload_event
      e.returnValue = true;
    }
  }

  beforeNavigate(({ cancel }) => {
    if (
      isDirty &&
      !confirm(
        'Weet je zeker dat je de pagina wilt verlaten? Onopgeslagen veranderingen kunnen verloren gaan.',
      )
    ) {
      cancel();
    }
  });

  $: flagAsDirty(policy);

  function flagAsDirty(newPolicy: Policy) {
    // If the value has really changed, set dirty to true
    if (!isDirty && JSON.stringify(newPolicy) !== oldPolicyJSON) {
      isDirty = true;
    }
  }
</script>

<svelte:window on:beforeunload={beforeUnload} />

<svelte:head>
  <title>{policy.name || 'Nieuwe policy'} — Policies — FSC Policy Builder</title>
</svelte:head>

<div class="grid min-h-screen grid-cols-12">
  <Sidebar active="policies" />

  <div class="col-span-7 bg-slate-50 p-6 sm:col-span-8 lg:col-span-9">
    <h1 class="mb-3 text-2xl font-medium">
      {#if policy.name}
        Policy: <span class="rounded bg-slate-200 px-2 py-1.5 text-slate-950">{policy.name}</span>
      {:else if data.id === 'new'}
        Nieuwe policy
      {:else}
        Onbekende policy
      {/if}
    </h1>

    {#if $errorMessage}
      <ErrorMessage bind:message={$errorMessage} />
    {:else if $successMessage}
      <SuccessMessage bind:message={$successMessage} />
    {/if}

    <p class="mb-7">
      <a
        class="inline-flex items-center text-sm text-blue-600 hover:text-blue-700 hover:underline"
        href="/policies"
        ><svg class="mr-1 h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
          ><path
            fill="none"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            d="M5 12h14M5 12l6 6m-6-6l6-6"
          /></svg
        > Terug naar alle policies</a
      >
    </p>

    <label class="mb-2 block font-medium text-slate-600" for="name">Naam</label>
    <input
      bind:value={policy.name}
      type="text"
      id="name"
      class="mb-7 block w-full rounded-lg border border-gray-300 p-2.5 text-sm text-gray-800 placeholder:text-gray-400 focus:border-indigo-500 focus:outline-none focus:ring-1 focus:ring-indigo-500"
      placeholder="Naam van de policy"
      autocomplete="off"
    />

    <h2 class="mb-3 text-xl font-medium">Regels</h2>
    <p class="mb-7">
      Verkeer wordt door de policy tegenhouden, tenzij dit door regels wordt toegestaan en niet door
      andere regels wordt geblokkeerd.
    </p>

    {#each policy.rules as _, i (i)}
      <div class="mb-7 rounded-md border border-slate-200 bg-white p-4">
        <DeleteButton on:click={deleteRule(i)} />

        <p class="mb-5">
          <Dropdown
            bind:value={policy.rules[i].effect}
            options={[
              { value: 'allow', label: 'Sta toe' },
              { value: 'deny', label: 'Blokkeer' },
            ]}
            color={policy.rules[i].effect === 'allow' ? 'emerald' : 'red'}
          /> als
        </p>

        <ExpressionElement bind:value={policy.rules[i].condition} />
      </div>
    {/each}

    <p class="mb-7">
      <button
        on:click={() => {
          policy.rules = [
            ...policy.rules,
            {
              condition: {
                operator: 'always',
                body: null,
              },
              effect: 'allow',
            },
          ];
        }}
        class="inline-flex items-center rounded-lg border border-indigo-300 bg-white px-2.5 py-1.5 text-sm font-medium text-indigo-800 shadow-sm hover:border-indigo-400 hover:bg-indigo-100 hover:text-indigo-900 focus:outline-none focus:ring-4 focus:ring-indigo-100"
        type="button"
      >
        <svg class="-ml-0.5 mr-2 h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24">
          <path
            fill="none"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            d="M12 5v14m-7-7h14"
          />
        </svg>
        Voeg regel toe
      </button>
    </p>

    <p class="mb-7">
      <button
        on:click={savePolicy}
        type="button"
        class="inline-block rounded-lg border border-indigo-600 bg-indigo-500 px-4 py-2.5 align-middle text-sm font-medium text-white shadow-sm hover:border-indigo-700 hover:bg-indigo-600 focus:outline-none focus:ring-4 focus:ring-indigo-200"
      >
        Opslaan
      </button>

      <a
        class="mr-4 inline-block rounded-lg border border-indigo-300 bg-white px-4 py-2.5 align-middle text-sm font-medium text-indigo-800 shadow-sm hover:border-indigo-300 hover:bg-indigo-100 hover:text-indigo-950 focus:outline-none focus:ring-4 focus:ring-slate-200"
        href="/policies"
      >
        Annuleren
      </a>

      <button
        on:click={() => {
          if (confirm('Weet je zeker dat je deze policy wilt verwijderen?')) {
            deletePolicy();
          }
        }}
        type="button"
        class="inline-flex items-center rounded-lg border border-red-300 bg-white px-4 py-2.5 align-middle text-sm font-medium text-red-800 shadow-sm hover:border-red-700 hover:bg-red-600 hover:text-white focus:outline-none focus:ring-4 focus:ring-red-200"
      >
        <svg class="-ml-0.5 mr-2 h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
          ><path
            fill="none"
            stroke="currentColor"
            stroke-linecap="round"
            stroke-linejoin="round"
            stroke-width="2"
            d="M4 7h16m-10 4v6m4-6v6M5 7l1 12a2 2 0 0 0 2 2h8a2 2 0 0 0 2-2l1-12M9 7V4a1 1 0 0 1 1-1h4a1 1 0 0 1 1 1v3"
          /></svg
        >
        Verwijder deze policy
      </button>
    </p>
  </div>
</div>
